> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an Instant Conversion between user Wallets

This call triggers an immediate conversion at the market rate, of the debited funds to the credited wallet at the market rate. A quote is not required for an instant conversion.

### Body parameters

<ParamField body="AuthorId" type="string" required>
  The unique identifier of the user at the source of the transaction. In a conversion, both the debited and credited wallets are owned by the author.
</ParamField>

<ParamField body="DebitedWalletId" type="string" required>
  The unique identifier of the debited wallet (in the sell currency).
</ParamField>

<ParamField body="CreditedWalletId" type="string" required>
  The unique identifier of the credited wallet (in the buy currency).
</ParamField>

<ParamField body="DebitedFunds" type="object" required>
  Information about the debited funds.

  <Expandable title="properties">
    <ParamField body="Currency" type="string" required>
      **Allowed values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

      The currency of the debited funds (the sell currency).
    </ParamField>

    <ParamField body="Amount" type="integer" required>
      An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).

      During a conversion, (`DebitedFunds.Amount` - `Fees`) \* `MarketRate` = `CreditedFunds.Amount`. 
    </ParamField>
  </Expandable>
</ParamField>

<ParamField body="CreditedFunds" type="object" required>
  Information about the credited funds.

  <Expandable title="properties">
    <ParamField body="Currency" type="string" required>
      **Allowed values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

      The currency of the credited funds (the buy currency).
    </ParamField>
  </Expandable>
</ParamField>

<ParamField body="Fees" type="object">
  Information about the fees taken by the platform for this transaction (and hence transferred to the Fees Wallet).

  <Expandable title="properties">
    <ParamField body="Type" type="string | null">
      **Allowed values:** `PERCENTAGE`, `FIXED`

      **Default value:** `FIXED`

      The type of the `Value`.
    </ParamField>

    <ParamField body="Value" type="integer" required>
      The value to be used for the `Type`:

      * `PERCENTAGE` – In quantities of 0.1% (e.g. `150` equals 1.5%), the percentage of `DebitedFunds.Amount` deducted as fees.
      * `FIXED` – The amount deducted from `DebitedFunds.Amount` as fees, as an amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
    </ParamField>

    <ParamField body="Currency" type="string" required>
      **Allowed values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

      The currency of the fees, which must match the debited currency.
    </ParamField>

    <ParamField body="Amount" type="integer" deprecated>
      For backwards compatibility, the `Amount` is accepted if sent instead of the `Value`.
    </ParamField>
  </Expandable>
</ParamField>

<ParamField body="UserMargin" type="object">
  Information about an indicative margin your platform can calculate and charge to the user after conversion. These values are used to calculate the `ConversionRateResponse.FinalRate` and the `MarginsResponse.User` in the API response.

  <Expandable title="properties">
    <ParamField body="Type" type="string" required>
      **Allowed values:** `PERCENTAGE`, `PIP`

      The type of the `Value`.
    </ParamField>

    <ParamField body="Value" type="float" required>
      The value of the `Type`:

      <Tabs>
        <Tab title="PERCENTAGE">
          Max. value: `10.0` (10%); max. 16 decimal places

          The quantities of 1% used to calculate the user margin.
        </Tab>

        <Tab title="PIP">
          Max value: `1000.0`

          The quantities of `0.0001` (one pip) used to calculate the user margin.
        </Tab>
      </Tabs>
    </ParamField>

    <ParamField body="Currency" type="string" required>
      **Allowed values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

      The currency of the fees, which must match the debited currency.
    </ParamField>
  </Expandable>
</ParamField>

<ParamField body="Tag" type="string">
  Max. length: 255 characters

  Custom data that you can add to this object.
</ParamField>

### Responses

<AccordionGroup>
  <Accordion title="200 - Succeeded">
    <ResponseField name="Id" type="string">
      Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

      The unique identifier of the object.
    </ResponseField>

    <ResponseField name="Type" type="string">
      The type of transaction.
    </ResponseField>

    <ResponseField name="Nature" type="string">
      **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

      The nature of the transaction, providing more information about the context in which the transaction occurred:

      * `REGULAR` – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow.
      * `REPUDIATION` – Automatic withdrawal of funds from the platform’s repudiation wallet as part of the dispute process (when the user has requested a chargeback).
      * `REFUND` – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay).
      * `SETTLEMENT` – Transfer made to the repudiation wallet by the platform to settle a lost dispute.
    </ResponseField>

    <ResponseField name="CreationDate" type="Unix timestamp">
      The date and time at which the object was created.
    </ResponseField>

    <ResponseField name="Status" type="string">
      **Returned values:** `CREATED`, `SUCCEEDED`, `FAILED`

      The status of the transaction.
    </ResponseField>

    <ResponseField name="AuthorId" type="string">
      The unique identifier of the user at the source of the transaction. In a conversion, both the debited and credited wallets are owned by the author.
    </ResponseField>

    <ResponseField name="DebitedWalletId" type="string">
      The unique identifier of the debited wallet (in the sell currency).
    </ResponseField>

    <ResponseField name="CreditedWalletId" type="string">
      The unique identifier of the credited wallet (in the buy currency).
    </ResponseField>

    <ResponseField name="DebitedFunds" type="object">
      Information about the debited funds.

      <Expandable title="properties">
        <ResponseField name="Currency" type="string">
          **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the debited funds (the sell currency).
        </ResponseField>

        <ResponseField name="Amount" type="integer">
          An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).

          During a conversion, (`DebitedFunds.Amount` - `Fees`) \* `MarketRate` = `CreditedFunds.Amount`. 
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="CreditedFunds" type="object">
      Information about the credited funds.

      <Expandable title="properties">
        <ResponseField name="Currency" type="string">
          **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the credited funds (the buy currency).
        </ResponseField>

        <ResponseField name="Amount" type="integer">
          An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).

          During a conversion, `CreditedFunds.Amount` = (`DebitedFunds.Amount` - `Fees`) \* `MarketRate`. 
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="Fees" type="object">
      Information about the fees taken by the platform for this transaction (and hence transferred to the Fees Wallet).

      **Note:** The fees currency must match the debited funds currency.

      <Expandable title="properties">
        <ResponseField name="Currency" type="string">
          **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the fees.
        </ResponseField>

        <ResponseField name="Amount" type="integer">
          An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="RequestedFees" type="object">
      Information about the `Fees` sent in the request.

      <Expandable title="properties">
        <ResponseField name="Type" type="string">
          **Allowed values:** `PERCENTAGE`, `FIXED`

          **Default value:** `FIXED`

          The type of the `Value`.
        </ResponseField>

        <ResponseField name="Value" type="integer">
          The value to be used for the `Type`:

          * `PERCENTAGE` – In quantities of 0.1% (e.g. `150` equals 1.5%), the percentage of `DebitedFunds.Amount` deducted as fees.
          * `FIXED` – The amount deducted from `DebitedFunds.Amount` as fees, as an amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
        </ResponseField>

        <ResponseField name="Currency" type="string">
          **Allowed values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the fees, which must match the debited currency.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="ResultCode" type="string">
      The code indicating the result of the operation. This information is mostly used to <a href="/errors/codes">handle errors</a> or for filtering purposes.
    </ResponseField>

    <ResponseField name="ResultMessage" type="string">
      The explanation of the result code.
    </ResponseField>

    <ResponseField name="ExecutionDate" type="Unix timestamp">
      The date and time at which the status changed to `SUCCEEDED`, indicating that the transaction occurred. The statuses `CREATED` and `FAILED` return an `ExecutionDate` of `null`.
    </ResponseField>

    <ResponseField name="ConversionRateResponse" type="object">
      Information about the `MarketRate` used to convert funds and other indicative rates.

      <Expandable title="properties">
        <ResponseField name="ClientRate" type="float">
          Max. 7 decimal places

          The indicative rate including Mangopay's markup, used during the billing cycle: `ClientRate` = `MarketRate` \* (1 - `MarginsResponse.Mangopay`). The `MarginsResponse.Mangopay.Amount` gives the amount of debited currency that will be billed by Mangopay to your platform for the transaction.

          The `ClientRate` fluctuates in line with the `MarketRate`.
        </ResponseField>

        <ResponseField name="MarketRate" type="float">
          Max. 7 decimal places

          The rate used to convert funds during the conversion: (`DebitedFunds.Amount` - `Fees`) \* `MarketRate` = `CreditedFunds.Amount`.

          The market rate fluctuates in line with FX market dynamics and is common to all platforms for the currency pair.
        </ResponseField>

        <ResponseField name="FinalRate" type="float">
          Max. 7 decimal places

          The indicative rate including the `UserMargin`, if your platform defined it in the request or the quote: `FinalRate` = `ClientRate` \* (1 - `MarginsResponse.User`). The `MarginsResponse.User.Amount` gives the amount of debited currency that your platform could bill to the user for the transaction.

          If no `UserMargin` was included, the `FinalRate` is the same as the `ClientRate`.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="MarginsResponse" type="object">
      Information about the margins calculated for the transaction.

      <Expandable title="properties">
        <ResponseField name="Mangopay" type="object">
          The margin used by Mangopay to bill your platform (which is defined during contracting).

          <Expandable title="properties">
            <ResponseField name="Type" type="string">
              Response value: `PERCENTAGE`

              The type of the `Value`, which for Mangopay is always `PERCENTAGE`.
            </ResponseField>

            <ResponseField name="Value" type="float">
              The value to be used for the `Type`.

              Mangopay's markup is expressed as a percentage (to convert to decimal, divide by 100).
            </ResponseField>

            <ResponseField name="Amount" type="integer">
              The amount of debited currency that Mangopay will charge your platform for the transaction during the billing cycle.
            </ResponseField>
          </Expandable>
        </ResponseField>

        <ResponseField name="User" type="object | null">
          The margin your platform could use to bill the user, as calculated by `UserMargin` in the request or quote (otherwise `null` if not set).

          <Expandable title="properties">
            <ResponseField name="Type" type="string">
              Response values: `PERCENTAGE`, `PIP`

              The type of the `Value`.
            </ResponseField>

            <ResponseField name="Value" type="float">
              The value to be used for the `Type`:

              * `PERCENTAGE` - The quantities of 1% used to calculate the user margin.
              * `PIP` - The quantities of `0.0001` (one pip) used to calculate the user margin.
            </ResponseField>

            <ResponseField name="Amount" type="integer">
              The amount of debited currency that your platform could bill to the user for the transaction.
            </ResponseField>
          </Expandable>
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="Tag" type="string">
      Max. length: 255 characters

      Custom data that you can add to this object.
    </ResponseField>
  </Accordion>
</AccordionGroup>

Functional errors (`ResultCode`) are possible on a 200 response. <a href="/errors/codes#fx-conversions">Read more</a> **→**

***

<AccordionGroup>
  <Accordion title="400 - Author not debited wallet owner">
    ```json theme={null}
    {
        "Message": "Author 45671234 is not debited wallet 204089031 owner.",
        "Type": "author_is_not_debited_wallet_owner",
        "Id": "5251717e-0965-4e33-a85a-a1042775913f",
        "Date": 1699532783,
        "errors": null
    }  
    ```
  </Accordion>

  <Accordion title="400 - Author not credited wallet owner">
    ```json theme={null}
    {
        "Message": "Author 204068024 is not credited wallet 208282959 owner.",
        "Type": "author_is_not_credited_wallet_owner",
        "Id": "f072dcfd-d02c-4489-835f-7abe0b11fa66",
        "Date": 1699532982,
        "errors": null
    }  
    ```
  </Accordion>

  <Accordion title="400 - Debited funds currency doesn’t match debited wallet currency">
    ```json theme={null}
    {
        "Message": "Debited currency incompatibility.",
        "Type": "currency_incompatibility",
        "Id": "af071186-b891-4e0d-baeb-736c15a757e8",
        "Date": 1699532861,
        "errors": null
    }  
    ```
  </Accordion>

  <Accordion title="400 - Credited funds currency doesn’t match credited wallet currency">
    ```json theme={null}
    {
        "Message": "Credited currency incompatibility.",
        "Type": "currency_incompatibility",
        "Id": "2466e688-5f4f-4dfa-8ebe-97b5608c3dd5",
        "Date": 1699532915,
        "errors": null
    }  
    ```
  </Accordion>

  <Accordion title="400 - Fees currency doesn't match debited funds currency">
    ```json theme={null}
    {
        "Message": "One or several required parameters are missing or incorrect. An incorrect resource ID also raises this kind of error.",
        "Type": "param_error",
        "Id": "f19eafbd-0310-4814-8f6b-691910b7b4a2",
        "Date": 1707323047,
        "errors": {
            "Fees.Currency": "Provided currency USD does not match debit currency of GBP"
        }
    }  
    ```
  </Accordion>
</AccordionGroup>

<AccordionGroup>
  <Accordion title="403 - Currency not activated">
    ```json theme={null}
    {
        "Message": "The currency JPY is not enabled for Forex. Contact your support to activate this feature.",
        "Type": "forex_not_available",
        "Id": "f8701d45-2540-4497-a7ce-4a3bc3181d68",
        "Date": 1699533051,
        "errors": null
    }  
    ```
  </Accordion>

  <Accordion title="403 - FX feature not activated">
    ```json theme={null}
    {
        "Message": "Forex module is not enabled. Contact your support to activate this feature.",
        "Type": "forbidden_ressource",
        "Id": "812b8909-9fb1-45b5-9000-06e8c8d73687",
        "Date": 1699533020,
        "errors": null
    }  
    ```
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json 200 - Succeeded   theme={null}
  {
      "Id": "cvr_01KH3K4ZER63X4KT634TJZHWE1",
      "Type": "CONVERSION",
      "Nature": "REGULAR",
      "CreationDate": 1770721017,
      "Status": "SUCCEEDED",
      "AuthorId": "user_m_01KGHXXFF6AQZA68MESVQVY7RA",
      "DebitedWalletId": "wlt_m_01KGSJDM69VNXPKKGH1B3QFVFC",
      "CreditedWalletId": "wlt_m_01KGSJ7GQY0P12EBB6XFAC866C",
      "DebitedFunds": {
          "Currency": "GBP",
          "Amount": 1000
      },
      "CreditedFunds": {
          "Currency": "EUR",
          "Amount": 1067
      },
      "Fees": {
          "Currency": "GBP",
          "Amount": 70
      },
      "RequestedFees": {
          "Type": "PERCENTAGE",
          "Value": 700,
          "Currency": "GBP"
      },
      "ResultCode": "000000",
      "ResultMessage": "Success",
      "ExecutionDate": 1770721018,
      "ConversionRateResponse": {
          "ClientRate": 1.13798,
          "MarketRate": 1.1471573,
          "FinalRate": 1.1209103
      },
      "MarginsResponse": {
          "Mangopay": {
              "Type": "PERCENTAGE",
              "Value": 0.8,
              "Amount": 8
          },
          "User": {
              "Type": "PERCENTAGE",
              "Value": 1.5,
              "Amount": 16
          }
      },
      "Tag": "Created using the Mangopay API Postman collection"
  }
  ```
</ResponseExample>

<RequestExample>
  ```json REST   theme={null}
  {
      "AuthorId": "user_m_01KGHXXFF6AQZA68MESVQVY7RA",
      "CreditedWalletId": "wlt_m_01KGSJ7GQY0P12EBB6XFAC866C",
      "DebitedWalletId": "wlt_m_01KGSJDM69VNXPKKGH1B3QFVFC",
      "DebitedFunds": {
          "Currency": "GBP",
          "Amount": 1000
      },
      "CreditedFunds": {
          "Currency": "EUR"
      },
      "Fees": {
          "Type": "PERCENTAGE",
          "Value": 700,
          "Currency": "GBP"
      },
      "UserMargin": {
          "Type": "PERCENTAGE",
          "Value": 1.5,
          "Currency": "GBP"
      },
      "Tag": "Created using the Mangopay API Postman collection"
  }
  ```

  ```php PHP  theme={null}
  <?php 

  require_once '../vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;
  use MangoPay\Money;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'client-id';
  $api->Config->ClientPassword = 'api-key';
  $api->Config->TemporaryFolder = '../tmp/';
  $api->Config->DebugMode = false;

  try { 
      $instantConversion = new \MangoPay\Conversion();

      $debitedUserId = "user_m_01HQK25M6KVHKDV0S36JY9NRKR";
      $debitedWalletId = "wlt_m_01HQT7AS0FJPGYXDXJ0R151NBV";
      $creditedWalletId = "wlt_m_01HQT6422EER2N7FPRXWTSDCSV";

      $instantConversion->AuthorId = $debitedUserId;
      $instantConversion->DebitedWalletId = $debitedWalletId;
      $instantConversion->CreditedWalletId = $creditedWalletId;
      $instantConversion->DebitedFunds = new Money();
      $instantConversion->DebitedFunds->Amount = 100;
      $instantConversion->DebitedFunds->Currency = "GBP";
      $instantConversion->CreditedFunds = new Money();
      $instantConversion->CreditedFunds->Currency = "EUR";
      $instantConversion->Tag = "Created using the Mangopay PHP SDK";

      $response = $api->Conversions->CreateInstantConversion($instantConversion);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print_r($e);
  }
  ```

  ```java Java   theme={null}
  import com.google.gson.Gson;
  import com.google.gson.GsonBuilder;
  import com.mangopay.MangoPayApi;
  import com.mangopay.core.Money;
  import com.mangopay.core.enumerations.CurrencyIso;
  import com.mangopay.entities.Conversion;
  import com.mangopay.entities.CreateInstantConversion;

  public class CreatingInstantConversion {

      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          var debitedUserId = "user_m_01HQK25M6KVHKDV0S36JY9NRKR";
          var debitedWalletId = "wlt_m_01HQT7AS0FJPGYXDXJ0R151NBV";
          var creditedWalletId = "wlt_m_01HQT6422EER2N7FPRXWTSDCSV";

          CreateInstantConversion instantConversion = new CreateInstantConversion();
          instantConversion.setAuthorId(debitedUserId);
          instantConversion.setCreditedWalletId(creditedWalletId);
          instantConversion.setDebitedWalletId(debitedWalletId);

          Money debitedFunds = new Money();
          debitedFunds.setCurrency(CurrencyIso.GBP);
          debitedFunds.setAmount(100);

          Money creditedFunds = new Money();
          creditedFunds.setCurrency(CurrencyIso.EUR);

          Money fees = new Money();
          fees.setCurrency(CurrencyIso.GBP);
          fees.setAmount(10);

          instantConversion.setCreditedFunds(creditedFunds);
          instantConversion.setDebitedFunds(debitedFunds);
          instantConversion.setFees(fees);
          instantConversion.setTag("Created using the Mangopay Java SDK");

          Conversion createInstantConversion = mangopay.getConversionsApi().createInstantConversion(instantConversion, null);

          Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
          String prettyJson = prettyPrint.toJson(createInstantConversion);

          System.out.println(prettyJson);
      }
  }
  ```
</RequestExample>
